#ifndef THREAD_HH__
#define THREAD_HH__

#include <pthread.h>
#include <string>

class ThreadError {
	const std::string message_;
public:
	ThreadError(const std::string& message);
	const std::string& get_message() const;
};

class Thread {
	pthread_t thread_id_;

	static void* internal_run(void* arg);
public:
	Thread();
	void start();
	virtual void run()=0;
};

#endif
